// hardware.h
#include <stdlib.h>
#include <stdint.h>
#include <assert.h>
#include <stdint.h>

// ATMega processors
#include <util/delay.h>
#include <avr/io.h>			/* Pin manipulation functions */
#include <avr/pgmspace.h>
#include <avr/eeprom.h>		/*        */
#include <avr/interrupt.h>

#define CPU_FREQ F_CPU

#define CPUSTYLE_ATMEGA 1
#define TICKS_FREQUENCY		((unsigned) (F_CPU / 256 / 256))	// At ATMega ~ 122.0703125 Hz
#define NOINLINEAT

#define enableIRQ() do { sei(); } while (0)
#define disableIRQ() do { cli(); } while (0)

/*     ""    . */
#define NTICKS(delayms) ((uint_fast16_t) ((uint_fast32_t) delayms * TICKS_FREQUENCY / 1000UL))


void hardware_adc_initialize(void);
void hardware_timer_initialize(void);
uint_fast8_t hardware_adc_started(void);
uint_fast8_t hardware_ged_pressed_key(uint8_t * scancode);

void hardware_cat_initialize(uint_fast8_t withirq);
void hardware_cat_set_speed(unsigned baudrate);

void cat_parsechar(uint_fast8_t c);	//  
